$!-----------------------------------------------------------------------------
$! BUILD_SWISHESI.COM
$!
$! P1 == LINK or BUILD or empty (builds)
$! P2 == "JUST:SWISHESI" then skip over build of CGILIB
$!
$! Determines environment by looking for hints in the build procedure device
$! so help things along by setting default to the environment concealed root.
$! Suggested locations:  HT_ROOT:[SRC.MISC]
$!                       WWW_ROOT:[SCRIPT_CODE.WASD]
$!                       APACHE_ROOT:[WASD]
$!
$! 05-JAN-2002  MGD  2.1-dev-25 suppress ZEROELEMENTS warning
$! 07-JUL-2001  MGD  (in)directly support multiple environments
$! 25-NOV-2000  MGD  initial development
$!-----------------------------------------------------------------------------
$!
$ SWISHE_VERSION = "2.1-dev-25"
$!
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT "Building ""SWISHESI""" +-
                   " for ""''F$GETSYI("ARCH_NAME")'"" architecture"
$!
$ IF F$TRNLNM("SWISHE_ROOT") .EQS. ""
$ THEN
$    WRITE SYS$OUTPUT "Error: no SWISHE_ROOT defined, use:"
$    WRITE SYS$OUTPUT "       $ DEFINE /TRANS=CONCEALED SWISHE_ROOT device:[dir.]"
$    EXIT
$ ENDIF
$ IF F$SEARCH("SWISHE_ROOT:[SRC]SWISH.H") .EQS. ""
$ THEN
$    WRITE SYS$OUTPUT "Error: could not locate SWISHE_ROOT:[SRC]SWISH.H"
$    EXIT
$ ENDIF
$!
$ ARCH_NAME = F$EDIT(F$GETSYI("ARCH_NAME"),"UPCASE")
$ IF ARCH_NAME .EQS. "ALPHA" THEN ARCH_NAME = "AXP"
$ PROC_DEV = F$PARSE(F$ENVIRONMENT("PROCEDURE"),,,"DEVICE")
$!
$!(assume CGILIB #include is in same directory except for WASD)
$ INCLUDES = " /INCLUDE=([])"
$ IF PROC_DEV .EQS. "HT_ROOT:" THEN INCLUDES = " /INCLUDE=([SRC.MISC])"
$ DEFINES = " /DEFINE=(_VMS_V6_SOURCE=1,__VMS_VER=60000000," +-
  "__CRTL_VER=60000000,CGILIB_OBJECT_MODULE," +-
  "HAVE_CONFIG_H,STDC_HEADERS,""SWISH_VERSION=""""''SWISHE_VERSION'"""""")"
$ WARNINGS=  " /WARNING=(DISABLE=(ZEROELEMENTS,PREOPTW,PROTOSCOPE))"
$ CC_OPTIONS = "/DECC /OPTIMIZE /STAND=RELAXED_ANSI /PREFIX=ALL" +-
               INCLUDES + DEFINES + WARNINGS
$!
$ IF F$SEARCH("OBJ_''ARCH_NAME'.DIR") .EQS. "" -
     THEN CREATE /DIR [.OBJ_'ARCH_NAME']
$ OBJECT_DIR = "[.OBJ_''ARCH_NAME']"
$!
$ IF P1 .EQS. "" .OR. P1 .EQS. "BUILD" .OR. P1 .EQS. "COMPILE"
$ THEN
$    SET NOON
$    IF P2 .NES. "JUST:SWISHESI"
$    THEN
$       SET VERIFY
$       CC 'CC_OPTIONS' /OBJECT='OBJECT_DIR' CGILIB
$!      'F$VERIFY(0)
$    ENDIF
$    SET VERIFY
$    DEFINE /USER VMS SWISHE_ROOT:[SRC.VMS]
$    CC 'CC_OPTIONS' /OBJECT='OBJECT_DIR' SWISHESI
$!   'F$VERIFY(0)
$    SET ON
$ ENDIF
$!
$ IF P1 .EQS. "" .OR. P1 .EQS. "BUILD" .OR. P1 .EQS. "LINK"
$ THEN
$    EXE_DIR = ""
$    IF PROC_DEV .EQS. "APACHE_ROOT:" THEN EXE_DIR = "CGI-BIN:[000000]"
$    IF PROC_DEV .EQS. "WWW_ROOT:" THEN EXE_DIR = "WWW_ROOT:[BIN]"
$    IF PROC_DEV .EQS. "HT_ROOT:" THEN EXE_DIR = "HT_EXE:"
$    SET NOON
$    SET VERIFY
$    LINK /EXECUTABLE='EXE_DIR'SWISHESI.EXE -
     'OBJECT_DIR'SWISHESI,CGILIB,-
     SWISHE_ROOT:[SRC]LIBSWISH-E.OLB/LIBRARY
$    SET PROTECTION=W:RE 'EXE_DIR'SWISHESI.EXE
$!   'F$VERIFY(0)
$    SET ON
$ ENDIF
$ PURGE /NOLOG 'OBJECT_DIR'
$!
$!-----------------------------------------------------------------------------
